﻿using System.Text;
using System.Threading.Tasks;
using Vintagestory.API.Client;
using Vintagestory.API.Server;
using Vintagestory.API.Common;
using Vintagestory.GameContent;
using Vintagestory.API.Config;
using Vintagestory.API.MathTools;
using Vintagestory.API.Common.Entities;
using ProtoBuf;

namespace vsmovemod.src
{
    class BehaviorCrawling
    {
        public static void Crawling(IClientPlayer player, ICoreClientAPI api)
        {
            // Get BLock above
            Block aboveBlock = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z);

            // Get Block "air"
            Block air = api.World.GetBlock(new AssetLocation("air"));

            // Crawl funtion hitbox and animation
            if (DataFields.isCrawling)
            {
                player.Entity.Properties.CanClimbAnywhere = false;
                player.Entity.StartAnimation("liegen");
                player.Entity.SetCollisionBox(0.5f, 0.5f); 
                player.Entity.Properties.SetEyeHeight(0.6);
                player.Entity.Properties.CollisionBoxSize = new Vec2f(0.5996094f, 0.9248045f);

                if (player.Entity.Controls.TriesToMove)
                {
                    player.Entity.StopAnimation("liegen");
                    player.Entity.StartAnimation("gleiten");
                }
                else
                {
                    player.Entity.StopAnimation("gleiten");
                    player.Entity.StartAnimation("liegen");
                }

                // InputEventListener - Disable actions
                api.Input.InWorldAction += MoveMod.Input_InWorldAction;

                if (player.Entity.CurrentControls == ((EnumEntityActivity)8 | (EnumEntityActivity)1))
                {
                    api.Input.InWorldAction += MoveMod.Input_InWorldAction2;
                }
                else if (player.Entity.CurrentControls == ((EnumEntityActivity)8 | (EnumEntityActivity)2))
                {
                    api.Input.InWorldAction += MoveMod.Input_InWorldAction2;
                }
                else if (player.Entity.CurrentControls == (EnumEntityActivity)2)
                {
                    player.Entity.Controls.StopAllMovement();
                    api.Input.InWorldAction += MoveMod.Input_InWorldAction;
                }
                else if (player.Entity.CurrentControls == ((EnumEntityActivity)4 | (EnumEntityActivity)2))
                {
                    player.Entity.Controls.StopAllMovement();
                    api.Input.InWorldAction += MoveMod.Input_InWorldAction;
                }
                else
                {
                    api.Input.InWorldAction += MoveMod.Input_InWorldAction;
                }
            }

            // Stop crawling
            if (aboveBlock == air || aboveBlock.IsLiquid())
            {
                if (((api.Input.MouseButton.Middle == true || DataFields.toggleStandup == true) && !DataFields.inBoatMode && DataFields.dashCountdown < 1 && player.Entity.CollidedVertically && DataFields.isCrawling == true) || (player.Entity.CurrentControls == (EnumEntityActivity.FloorSitting | EnumEntityActivity.Idle)))
                {
                    DataFields.isCrawling = false;
                    DataFields.toggleStandup = false;
                    player.Entity.StopAnimation("gleiten");
                    player.Entity.StopAnimation("liegen");
                    player.Entity.Properties.SetEyeHeight(1.7);
                    player.Entity.Properties.CollisionBoxSize = new Vec2f(0.5996094f, 1.849609f);

                    // InputEventListener
                    api.Input.InWorldAction += MoveMod.Input_InWorldAction1;
                }
            }

            //Reset toggleCrawl if not sneaking
            if (!player.Entity.Controls.Sneak)
            {
                DataFields.toggleCrawl = false;
            }

            //Start Crawl
            if ((player.Entity.Controls.Sneak && api.Input.MouseButton.Middle == true || player.Entity.Controls.Sneak && DataFields.toggleCrawl == true) && player.Entity.CollidedVertically && !DataFields.isCrawling && !(player.Entity.CurrentControls == (EnumEntityActivity.FloorSitting | EnumEntityActivity.Idle)))
            {
                DataFields.isCrawling = true;
                DataFields.toggleCrawl = false;
            }
        }
    }
}
