﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vintagestory.API.Client;
using Vintagestory.API.Server;
using Vintagestory.API.Common;
using Vintagestory.GameContent;
using Vintagestory.API.Config;
using Vintagestory.API.MathTools;
using Vintagestory.API.Common.Entities;
using ProtoBuf;

namespace vsmovemod.src
{
    class BehaviorFalldamage
    {
        // OnServerMessage overload
        // Called on Gliding through air - sets falldamage = false;
        private static void OnServerMessage(IClientNetworkChannel clientChannel)
        {
            clientChannel.SendPacket(new NetworkApiTestResponse()
            {
                response = false,
            });
        }

        // OnServerMessage overload
        // Called on leaving GliderMode - sets falldamage = true;
        private static void OnServerMessageLeave(IClientNetworkChannel clientChannel)
        {
            clientChannel.SendPacket(new NetworkApiTestResponse()
            {
                response = true,
            });
        }

        public static void SetFallDamage(IClientPlayer player, ICoreClientAPI api, IClientNetworkChannel clientChannel)
        {
            // Toggle fall-damage when gliding / climbing
            if (DataFields.inGliderMode || player.Entity.Controls.IsClimbing || DataFields.isHanging)
            {
                if (DataFields.getFallDamage)
                {
                    OnServerMessage(clientChannel);
                    DataFields.getFallDamage = false;
                }
            }
            else
            {
                if (!DataFields.getFallDamage)
                {
                    DataFields.fallDamageDelay++;
                    if (DataFields.fallDamageDelay > 50)
                    {
                        OnServerMessageLeave(clientChannel);
                        DataFields.fallDamageDelay = 0;
                        DataFields.getFallDamage = true;
                    }
                }
            }
        }
    }
}
