﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vintagestory.API.Client;
using Vintagestory.API.Server;
using Vintagestory.API.Common;
using Vintagestory.GameContent;
using Vintagestory.API.Config;
using Vintagestory.API.MathTools;
using Vintagestory.API.Common.Entities;
using ProtoBuf;

namespace vsmovemod.src
{
    class BehaviorHangclimbing
    {
        public static void Hanging(IClientPlayer player, ICoreClientAPI api)
        {
            Block air = api.World.GetBlock(new AssetLocation("air"));

            // Hanging
            Block aboveBlock2 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 2, (int)player.Entity.Pos.Z);

            if (aboveBlock2 != air && DataFields.stamina > 0 && !player.Entity.OnGround && player.Entity.Controls.Sneak && !player.Entity.Controls.TriesToMove && player.InventoryManager.ActiveHotbarSlot.Empty && DataFields.isClimbable == false)
            {
                Vec3d motionZero = new Vec3d(0, 0, 0);
                player.Entity.Pos.Motion = motionZero;

                player.Entity.Properties.Habitat = EnumHabitat.Air;
                player.Entity.Properties.CanClimbAnywhere = false;
                player.Entity.StopAnimation("hangingtop");
                player.Entity.StartAnimation("hangingidle");
                DataFields.stamina -= (DataFields.drainStaminaHanging * DataFields.drainStaminaIdleModificator);
                DataFields.isHanging = true;
            }
            else if (aboveBlock2 != air && DataFields.stamina > 0 && !player.Entity.OnGround && player.Entity.Controls.Sneak && player.Entity.Controls.TriesToMove && player.InventoryManager.ActiveHotbarSlot.Empty && DataFields.isClimbable == false)
            {
                player.Entity.Properties.Habitat = EnumHabitat.Air;
                player.Entity.Properties.CanClimbAnywhere = false;
                player.Entity.StopAnimation("hangingidle");
                player.Entity.StartAnimation("hangingtop");
                DataFields.stamina -= DataFields.drainStaminaHanging;
                DataFields.isHanging = true;
            }
            else if (aboveBlock2 != air && DataFields.stamina > 0 && !player.Entity.OnGround && player.Entity.Controls.IsClimbing && player.InventoryManager.ActiveHotbarSlot.Empty && DataFields.isClimbable == false)
            {
                player.Entity.Properties.Habitat = EnumHabitat.Air;
                player.Entity.Properties.CanClimbAnywhere = false;
                player.Entity.StopAnimation("hangingidle");
                player.Entity.StartAnimation("hangingtop");
                DataFields.stamina -= DataFields.drainStaminaHanging;
                DataFields.isHanging = true;
            }
            else
            {
                if (!DataFields.inGliderMode)
                {
                    player.Entity.Properties.Habitat = EnumHabitat.Land;
                    player.Entity.StopAnimation("hangingtop");
                    player.Entity.StopAnimation("hangingidle");
                    DataFields.isHanging = false;
                }
            }
        }
    }
}
