﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vintagestory.API.Client;
using Vintagestory.API.Server;
using Vintagestory.API.Common;
using Vintagestory.GameContent;
using Vintagestory.API.Config;
using Vintagestory.API.MathTools;
using Vintagestory.API.Common.Entities;
using ProtoBuf;

namespace vsmovemod.src
{
    class BehaviorStamina
    {
        public static void CalculateStamina(IClientPlayer player, ICoreClientAPI api)
        {
            //  0 Stamina Slow
            if (DataFields.stamina < 1 && player.Entity.OnGround)
            {
                Vintagestory.API.Config.GlobalConstants.OverallSpeedMultiplier = 0.75f;
            }
            else
            {
                Vintagestory.API.Config.GlobalConstants.OverallSpeedMultiplier = 1f;
            }

            //Delay Stamina Regen when Stamina < 1 (0)
            if (DataFields.stamina < 1 && DataFields.staminaRegenIsDelayed == false)
            {
                DataFields.staminaRegenDelay = DataFields.maxStaminaRegenDelay;
                DataFields.staminaRegenIsDelayed = true;
                DataFields.generalAudioDelay = 15;
            }

            // Sound no Stamina
            if (DataFields.stamina < 1 && DataFields.generalAudioDelay < 10)
            {
                api.World.PlaySoundFor(new AssetLocation("vsmovemod:sounds/nostam"), player, false, 0, 0.2f);
                DataFields.generalAudioDelay = 80;
            }

            // Stamina Regen
            if (DataFields.stamina < DataFields.maxStamina && ((!player.Entity.Controls.IsClimbing && player.Entity.CollidedVertically) || DataFields.inBoatMode) && DataFields.staminaRegenDelay < 1)
            {
                float staminaNewValue;
                staminaNewValue = (DataFields.stamina += DataFields.staminaRegenValue);

                if (staminaNewValue > DataFields.maxStamina)
                {
                    DataFields.stamina = DataFields.maxStamina;
                }
                else
                {
                    DataFields.stamina += DataFields.staminaRegenValue;
                }

                // Sound recover Stamina
                if (DataFields.generalAudioDelay < 60 && DataFields.staminaRegenIsDelayed)
                {
                    Random rnd = new Random();
                    api.World.PlaySoundFor(new AssetLocation("vsmovemod:sounds/recover"), player, false, 0, 0.2f);         
                    DataFields.generalAudioDelay = 80;
                }

                if (DataFields.stamina == DataFields.maxStamina)
                {
                    DataFields.staminaRegenIsDelayed = false;
                }
            }
        }
    }
}
