﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vintagestory.API.Common;

namespace vsmovemod.src
{
	internal class ConfigLoader
	{
		private string FileName = "VSMM_Config.json";
		
		private readonly ICoreAPI api;

		public ConfigLoader(ICoreAPI api)
		{
			this.api = api;
		}

		public Config LoadConfig()
		{
			Config modConfig = api.LoadModConfig<Config>(FileName);
			if (modConfig == null)
			{
				modConfig = GenerateConfig();
			}

			return modConfig;
		}

		private Config GenerateConfig()
		{
			Config config = new Config
			{
				Walkstep = false,
				MaxStamina = 100,
				StaminaRegenValue = 2,
				StaminaRegenDelay = 60,
				CostDash = 0.3333f,
				CostClimbing = 1f,
				CostHanging = 0.4f,
				CostGliding = 0.025f,
				CostLiftup = 0.001f,
		};

			Config modConfig = config;
			api.StoreModConfig<Config>(modConfig, FileName);

			return modConfig;
		}
	}
}
