﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vintagestory.API.Client;
using Vintagestory.API.Server;
using Vintagestory.API.Common;
using Vintagestory.GameContent;
using Vintagestory.API.Config;
using Vintagestory.API.MathTools;
using Vintagestory.API.Common.Entities;
using ProtoBuf;

namespace vsmovemod.src
{
    class DataFields
    {
        // Player UID
        public static string clientUID;

        // Counters
        public static int maxDashCountdown = 15; // Ticks (50ms) to reset dash & slide ability --- min 6 ! === Do not change ===
        public static int dashCountdown = 0;
        public static int soundGlidingCountdown = 0;
        public static int soundGlidingOverWaterCd = 0;
        public static int soundClimbinglCountdown = 0;
        public static int soundWavesCountdown = 0;
        public static int generalAudioDelay = 0;
        public static int fallDamageDelay = 0;
        public static int sailInputDelay = 0;
        public static int windDirectionTimer = 0;
        public static int boatUnmountTimer = 0;
        public static int errorTimer = 0;

        public static int dashTime = 5;
        public static int slideTime = 10;
        public static int gliderDelay = 0;

        // Stamina & Stamina-Drain
        public static float maxStamina; // Set by Config on Start
        public static float stamina = maxStamina;

        public static float drainStaminaClimbing; // Set by Config on Start
        public static float drainStaminaChargeJump = 0; // none
        public static float drainStaminaDash; // Set by Config on Start
        public static float drainStaminaHanging; // Set by Config on Start
        public static float drainStaminaGliding; // Set by Config on Start
        public static float drainStaminaLift; // Set by Config on Start
        public static float drainStaminaIdleModificator = 0.2f; // Stamina drain modificator while hanging / climbing idle (not moving) in %

        public static int maxStaminaRegenDelay; // Set by Config on StartTicks - x Ticks (50ms) until stamina-regeneration
        public static int staminaRegenDelay = 0; 
        public static int staminaRegenValue; // Set by Config on Start - Stamina regen per tick

        // Bools
        public static bool playerIsClimbing = false;
        public static bool isCrawling = false;
        public static bool isFalling = false;

        public static bool staminaRegenIsDelayed = false;
        public static bool isClimbable = false;
        public static bool isHanging = false;
        public static bool motionStopedAfterDash = true;
        public static bool letGoClimbing = false;
        public static bool switchedClimbingControls = false;

        // Charge jump
        public static int maxChargeJump = 100;
        public static int chargeJump = 0;

        //Boat
        public static bool placeBoatN = false;
        public static bool placeBoatE = false;
        public static bool placeBoatS = false;
        public static bool placeBoatW = false;

        public static bool removeBoat = false;

        public static bool toggleSailboat = false;
        public static bool inBoatMode = false;
        public static bool sailDown = false;

        public static bool moveSailLeft = false;
        public static bool moveSailRight = false;

        // Flight
        public static bool activateFlightComputer = false;
        public static bool wearingGliderT1 = false;
        public static int flightComputer_refresh = 10;

        public static int lastDurability;

        public static int refreshE_pot = 0;
        public static int refresh_lastX = 0;
        public static int refresh_lastZ = 0;
        public static int landingAnimBuffer = 0;
        public static int timeLanded = 0;

        public static bool inGliderMode = false;
        public static bool hasGlided = false;
        public static bool glideAnimToggled = false;
        public static bool nearGround;
        public static bool liftGreaterGravity = false;
        public static bool flightIsStalling = false;
        public static bool inert = false;
        public static bool hasPlayedControlSound = false;
        public static bool playerGlidingOverWater = false;

        public static double F_gravity = 1;
        public static double E_pot = 1;
        public static double F_lift;
        public static double F_drag;

        public static double surface_liftBase = 2;  // base-value == 2
        public static double surface_lift;
        public static double surface_dragBase = 2;  // base-value == 2
        public static double surface_drag;

        public static double temperature;
        public static double modTemperature;

        public static double windSpeed;
        public static double modWindSpeed;

        public static double motionSumXZ = 1;

        public static double lastX;
        public static double lastZ;

        public static int gliderInertTimer = 0; 

        // Debug bools
        public static bool getFallDamage = true;

        // Hotkey bools
        public static bool toggleStandup = false;
        public static bool toggleCrawl = false;
        public static bool toggleGlider = false;

        // CMD
        public static bool noStep = false;
        public static bool sprintStep = true;
        public static bool walkStep = false; // Set by Config on Start

        // Particles
        public static SimpleParticleProperties myParticles = new SimpleParticleProperties(1, 1, ColorUtil.ColorFromRgba(255, 255, 255, 1), new Vec3d(), new Vec3d(), new Vec3f(), new Vec3f());
        public static SimpleParticleProperties myWindParticles = new SimpleParticleProperties(1, 1, ColorUtil.ColorFromRgba(255, 255, 255, 1), new Vec3d(), new Vec3d(), new Vec3f(), new Vec3f());
        public static SimpleParticleProperties mySpecialParticles = new SimpleParticleProperties(1, 1, ColorUtil.ColorFromRgba(255, 255, 255, 1), new Vec3d(), new Vec3d(), new Vec3f(), new Vec3f());
        public static SimpleParticleProperties myWaterSplashParticles = new SimpleParticleProperties(1, 1, ColorUtil.ColorFromRgba(255, 255, 255, 1), new Vec3d(), new Vec3d(), new Vec3f(), new Vec3f());


        // Experimental
        public static bool slotChanged = false;
    }
}
