﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vintagestory.API;
using Vintagestory.API.Datastructures;
using Vintagestory.API.Client;
using Vintagestory.API.Server;
using Vintagestory.API.Common;
using Vintagestory.GameContent;
using Vintagestory.API.Config;
using Vintagestory.API.MathTools;
using Vintagestory.API.Common.Entities;
using ProtoBuf;


namespace vsmovemod.src
{
    enum Direction
    {
        North,
        South,
        East,
        West,
    }

    class ItemSailboat : ItemWearable
    {
        public static ItemSlot boatSlot;

        public static bool isWearingSailerShirt = false;
        public static bool hasSailed = false;
        public static bool boatCollided = false;
        public static bool boatJustEntered = false;
        public static bool mountedBoat = false;

        public static bool boatSteerStraight = false;
        public static bool boatSteerRight = false;
        public static bool boatSteerLeft = false;

        public static bool changedSteerDirection = true;
        public static bool changedSailDirection = true;

        public static float currentSpeed = speed1;
        public static float prevSpeed = speed1;
        public static float targetSpeed;

        public static float speed1 = 0.02f;
        public static float speed2 = 0.04f;
        public static float speed3 = 0.06f;
        public static float speed4 = 0.08f;

        public static bool handlerSaved = false;

        public static Direction playerDirection;
        public static Direction xwindDirection;

        public static int lastWindDirection = 0;

        public static ActionConsumable<KeyCombination> characterHandler;

        // 2 = behind, 1 = right, 3 = left, 4 = front
        public static int windDirection;

        // 1 = right, 2 = straight, 3 = left;
        public static int currentSteer;

        // 1 = right, 2 = straight, 3 = left;
        public static int sailDirection;

        public static bool playedBellSound = false;

        public static void UseSailboat(IClientPlayer player, ICoreClientAPI api)
        {

            var gearInv = player.Entity.GearInventory;
            Vec3d walkVector = player.Entity.Controls.WalkVector;

            // Sailshirt
            Item SailShirt = api.World.GetItem(new AssetLocation("game:armor-body-sewn-leather"));
            ItemStack StackSailShirt = new ItemStack(SailShirt, 1);

            Block air = api.World.GetBlock(new AssetLocation("air"));

            Block waterBlock = api.World.GetBlock(new AssetLocation("water-still-7"));
            int waterBlockID = api.World.GetBlock(new AssetLocation("water-still-7")).BlockId;

            Block boatBlockN= api.World.GetBlock(new AssetLocation("vsmovemod:boatblock-rear-north"));
            int boatBlockNID = api.World.GetBlock(new AssetLocation("vsmovemod:boatblock-rear-north")).BlockId;

            Block boatBlockE = api.World.GetBlock(new AssetLocation("vsmovemod:boatblock-rear-east"));
            int boatBlockEID = api.World.GetBlock(new AssetLocation("vsmovemod:boatblock-rear-east")).BlockId;

            Block boatBlockS = api.World.GetBlock(new AssetLocation("vsmovemod:boatblock-rear-south"));
            int boatBlockSID = api.World.GetBlock(new AssetLocation("vsmovemod:boatblock-rear-south")).BlockId;

            Block boatBlockW = api.World.GetBlock(new AssetLocation("vsmovemod:boatblock-rear-west"));
            int boatBlockWID = api.World.GetBlock(new AssetLocation("vsmovemod:boatblock-rear-west")).BlockId;

            Block aboveBlock = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z);
            Block above2Block = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 2, (int)player.Entity.Pos.Z);
            Block belowBlock = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y - 1, (int)player.Entity.Pos.Z);
            Block below2Block = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y - 2, (int)player.Entity.Pos.Z);
            Block playerPosBlock = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z);

            Block xplusBlock = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X + 1, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z);
            Block xminusBlock = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X - 1, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z);
            Block zplusBlock = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z + 1);
            Block zminusBlock = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z - 1);

            if (DataFields.inBoatMode)
            {
                // Get Player view direction N,S,E,W
                float direction = player.Entity.Pos.Yaw;

                //float yawDistN = GameMath.AngleRadDistance(player.Entity.BodyYaw, directionN);

                if (direction > 0.7855 && direction <= 2.3558)
                {
                    playerDirection = Direction.North;
                }
                else if (direction > 2.35 && direction <= 3.9268)
                {
                    playerDirection = Direction.West;
                }
                else if (direction > 3.9268 && direction <= 5.4977)
                {
                    playerDirection = Direction.South;
                }
                else
                {
                    playerDirection = Direction.East;
                }

                // Boat "collision"
                if (playerDirection == Direction.North)
                {
                    BlockPos blockPos = player.Entity.Pos.AsBlockPos;

                    Block blockInFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z - 1);
                    Block block2InFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z - 2);
                    Block block3InFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z - 3);

                    Block blockInFrontUp1 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 2, (int)player.Entity.Pos.Z - 2);
                    Block blockInFrontUp2 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 3, (int)player.Entity.Pos.Z - 2);
                    Block blockInFrontUp3 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 4, (int)player.Entity.Pos.Z - 2);

                    Block blockBehind = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z + 1);

                    Block blockInFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z - 1);
                    Block block2InFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z - 2);
                    Block block3InFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z - 3);

                    if (blockInFront != air || block2InFront != air || block3InFront != air || blockInFrontUp1 != air || blockInFrontUp2 != air || blockInFrontUp3 != air || !blockInFrontWater.IsLiquid() || !block2InFrontWater.IsLiquid() || !block3InFrontWater.IsLiquid())
                    {
                        boatCollided = true;
                    }
                    else
                    {
                        boatCollided = false;
                    }
                }
                else if (playerDirection == Direction.East)
                {
                    Block blockInFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X + 1, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z);
                    Block block2InFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X + 2, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z);
                    Block block3InFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X + 3, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z);

                    Block blockInFrontUp1 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X + 2, (int)player.Entity.Pos.Y + 2, (int)player.Entity.Pos.Z);
                    Block blockInFrontUp2 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X + 2, (int)player.Entity.Pos.Y + 3, (int)player.Entity.Pos.Z);
                    Block blockInFrontUp3 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X + 2, (int)player.Entity.Pos.Y + 4, (int)player.Entity.Pos.Z);

                    Block blockBehind = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X - 1, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z);

                    Block blockInFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X + 1, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z);
                    Block block2InFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X + 2, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z);
                    Block block3InFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z - 3);

                    if (blockInFront != air || block2InFront != air || block3InFront != air || blockInFrontUp1 != air || blockInFrontUp2 != air || blockInFrontUp3 != air || !blockInFrontWater.IsLiquid() || !block2InFrontWater.IsLiquid() || !block3InFrontWater.IsLiquid())
                    {
                        boatCollided = true;
                    }
                    else
                    {
                        boatCollided = false;
                    }
                }
                else if (playerDirection == Direction.South)
                {
                    Block blockInFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z + 1);
                    Block block2InFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z + 2);
                    Block block3InFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z + 3);

                    Block blockInFrontUp1 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 2, (int)player.Entity.Pos.Z + 2);
                    Block blockInFrontUp2 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 3, (int)player.Entity.Pos.Z + 2);
                    Block blockInFrontUp3 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 4, (int)player.Entity.Pos.Z + 2);

                    Block blockBehind = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z - 1);

                    Block blockInFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z + 1);
                    Block block2InFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z + 2);
                    Block block3InFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z - 3);

                    if (blockInFront != air || block2InFront != air || block3InFront != air || blockInFrontUp1 != air || blockInFrontUp2 != air || blockInFrontUp3 != air || !blockInFrontWater.IsLiquid() || !block2InFrontWater.IsLiquid() || !block3InFrontWater.IsLiquid())
                    {
                        boatCollided = true;
                    }
                    else
                    {
                        boatCollided = false;
                    }
                }
                else if (playerDirection == Direction.West)
                {
                    Block blockInFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X - 1, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z);
                    Block block2InFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X - 2, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z);
                    Block block3InFront = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X - 3, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z);

                    Block blockInFrontUp1 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X - 2, (int)player.Entity.Pos.Y + 2, (int)player.Entity.Pos.Z);
                    Block blockInFrontUp2 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X - 2, (int)player.Entity.Pos.Y + 3, (int)player.Entity.Pos.Z);
                    Block blockInFrontUp3 = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X - 2, (int)player.Entity.Pos.Y + 4, (int)player.Entity.Pos.Z);

                    Block blockBehind = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X + 1, (int)player.Entity.Pos.Y + 1, (int)player.Entity.Pos.Z);

                    Block blockInFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X - 1, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z);
                    Block block2InFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X - 2, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z);
                    Block block3InFrontWater = api.World.BlockAccessor.GetBlock((int)player.Entity.Pos.X, (int)player.Entity.Pos.Y, (int)player.Entity.Pos.Z - 3);

                    if (blockInFront != air || block2InFront != air || block3InFront != air || blockInFrontUp1 != air || blockInFrontUp2 != air || blockInFrontUp3 != air || !blockInFrontWater.IsLiquid() || !block2InFrontWater.IsLiquid() || !block2InFrontWater.IsLiquid())
                    {
                        boatCollided = true;
                    }
                    else
                    {
                        boatCollided = false;
                    }
                }
            }

            // save characterHandler
            if (!handlerSaved)
            {
                characterHandler = api.Input.HotKeys["characterdialog"].Handler;
                handlerSaved = true;
            }

            // Disable character dialog
            if (DataFields.inBoatMode)
            {
                if (api.Input.HotKeys["characterdialog"].Handler != null)
                {
                    api.Input.HotKeys["characterdialog"].Handler = null;
                }
            }

            // Reenable character dialog
            else if (!DataFields.inBoatMode)
            {
                if (api.Input.HotKeys["characterdialog"].Handler == null)
                {
                    api.Input.HotKeys["characterdialog"].Handler = characterHandler;
                }
            }

            
            if (DataFields.inBoatMode)
            {
                // Set Properties in Boatmode
                player.Entity.Properties.SetEyeHeight(0.8);

                // Headtracking for Direction
                if (player.Entity.HeadYaw >= -0.1 && player.Entity.HeadYaw <= 0.1 && !boatSteerStraight)
                {
                    boatSteerStraight = true;
                    boatSteerRight = false;
                    boatSteerLeft = false;
                    currentSteer = 2;

                    changedSteerDirection = true;
                }
                else if (player.Entity.HeadYaw > 0.1 && !boatSteerLeft)
                {
                    boatSteerStraight = false;
                    boatSteerRight = false;
                    boatSteerLeft = true;
                    currentSteer = 3;

                    changedSteerDirection = true;
                }
                else if (player.Entity.HeadYaw < -0.1 && !boatSteerRight)
                {
                    boatSteerStraight = false;
                    boatSteerRight = true;
                    boatSteerLeft = false;
                    currentSteer = 1;

                    changedSteerDirection = true;
                }

                //Cancel inputs when in baot mode
                api.Input.InWorldAction += Input_PreventMovement;
                player.Entity.StartAnimation("boatidle");
                player.Entity.StopAnimation("sprint");
                player.Entity.StopAnimation("walk");
                player.Entity.StopAnimation("awaitdash");
                player.Entity.StopAnimation("swim");

                // Bell sound when entering boatmode
                if (!playedBellSound)
                {
                    api.World.PlaySoundFor(new AssetLocation("sounds/creature/bell/bell"), player, false, 100, 5);
                    playedBellSound = true;
                }

                // Stop sinking when in boat mode
                if (DataFields.inBoatMode)
                {
                    Entity entity = player.Entity;
                    var pos = player.Entity.Pos;

                    Block inblock = entity.World.BlockAccessor.GetBlock((int)pos.X, (int)(pos.Y), (int)pos.Z);
                    Block aboveblock = entity.World.BlockAccessor.GetBlock((int)pos.X, (int)(pos.Y + 1), (int)pos.Z);
                    Block twoaboveblock = entity.World.BlockAccessor.GetBlock((int)pos.X, (int)(pos.Y + 2), (int)pos.Z);
                    float waterY = (int)pos.Y + inblock.LiquidLevel / 8f + (aboveblock.IsLiquid() ? 9 / 8f : 0) + (twoaboveblock.IsLiquid() ? 9 / 8f : 0);
                    float bottomSubmergedness = waterY - (float)pos.Y;

                    float swimlineSubmergedness = GameMath.Clamp(bottomSubmergedness - ((float)entity.SwimmingOffsetY - 1.5f), 0, 1);
                    swimlineSubmergedness = Math.Min(1, swimlineSubmergedness + 0.075f);

                    double yMot = 0;

                    yMot = 0.005f * swimlineSubmergedness * 0.05 * 60;

                    pos.Motion.Add(0, yMot, 0);
                }

                //Wind Direction RND   
                if (DataFields.windDirectionTimer == 0)
                {
                    // Set random duration
                    Random rndDuration = new Random();
                    DataFields.windDirectionTimer = rndDuration.Next(600, 1200);

                    // Set random wind-direction
                    Random rndDirection = new Random();
                    windDirection = rndDirection.Next(1, 4);

                    switch (windDirection)
                    {
                        case 1: xwindDirection = Direction.North; break;
                        case 2: xwindDirection = Direction.East; break;
                        case 3: xwindDirection = Direction.South; break;
                        case 4: xwindDirection = Direction.West; break;
                    }

                    if (lastWindDirection != windDirection)
                    {
                        lastWindDirection = windDirection;
                        player.ShowChatNotification("Wind direction changed: " + xwindDirection.ToString());
                    } 
                }

                //Move when sail is down
                if (DataFields.sailDown)
                {
                    float bodyYaw = player.Entity.BodyYaw;
                    Particles.SpawnWaterParticles(player.Entity, bodyYaw, 0.3f);
                    Particles.SpawnWaterParticles(player.Entity, bodyYaw, -0.3f);

                    // Sound when sail-down
                    if (!hasSailed)
                    {
                        sailDirection = 2;
                        api.World.PlaySoundFor(new AssetLocation("sounds/wearable/leather1"), player, false, 100, 5);
                    }

                    hasSailed = true;

                    // *** NEW WIND MECHANICS ***
                    if (xwindDirection == Direction.North && !boatCollided)
                    {
                        if (playerDirection == Direction.North)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed2;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.East && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.South && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.West && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                            }
                        }
                    }
                    else if (xwindDirection == Direction.East && !boatCollided)
                    {
                        if (playerDirection == Direction.North)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.East && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed2;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.South && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.West && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                            }
                        }
                    }
                    else if (xwindDirection == Direction.South && !boatCollided)
                    {
                        if (playerDirection == Direction.North)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.East && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.South && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed2;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.West && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                            }
                        }
                    }
                    else if (xwindDirection == Direction.West && !boatCollided)
                    {
                        if (playerDirection == Direction.North)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.East && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.South && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed3;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed4;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }

                                        if (DataFields.generalAudioDelay == 0)
                                        {
                                            api.World.PlaySoundFor(new AssetLocation("sounds/effect/swoosh"), player, false, 100, 5);
                                            DataFields.generalAudioDelay = 100;
                                        }
                                    }
                                    break;
                            }
                        }
                        else if (playerDirection == Direction.West && !boatCollided)
                        {
                            switch (sailDirection)
                            {
                                case 1:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 2:
                                    {
                                        targetSpeed = speed2;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                                case 3:
                                    {
                                        targetSpeed = speed1;

                                        if (currentSpeed < targetSpeed)
                                        {
                                            currentSpeed += 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else if (currentSpeed > targetSpeed)
                                        {
                                            currentSpeed -= 0.001f;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                        else
                                        {
                                            currentSpeed = targetSpeed;

                                            Vec3d vecAhead = player.Entity.Pos.Motion.Ahead(-1, 0, player.Entity.BodyYaw);
                                            player.Entity.Pos.Motion.X = vecAhead.X * currentSpeed;
                                            player.Entity.Pos.Motion.Z = vecAhead.Z * currentSpeed;
                                        }
                                    }
                                    break;
                            }
                        }
                    }
                    // *** END NEW WIND MECHANICS ***

                    // Sound when sailing
                    if (DataFields.soundWavesCountdown == 0)
                    {
                        api.World.PlaySoundFor(new AssetLocation("sounds/environment/waterwaves"), player, false, 100, 5);
                        DataFields.soundWavesCountdown = 200;

                        // Wood creek sound
                        api.World.PlaySoundFor(new AssetLocation("sounds/block/creak/woodcreak_long2"), player, false, 100, 5);
                    }

                    if (player.Entity.Controls.Left || player.Entity.Controls.Right)
                    {
                        player.Entity.StopAnimation("sprint");
                        player.Entity.StopAnimation("walk");
                        player.Entity.StopAnimation("awaitdash");
                    }

                    // Change Saildirection when sailDown States: 1 = right, 2 = straight, 3 = left
                    if (sailDirection == 1 && DataFields.sailInputDelay == 0)
                    {
                        if (DataFields.moveSailLeft)
                        {
                            sailDirection = 2;
                            changedSailDirection = true;

                            player.Entity.StopAnimation("boatright");

                            DataFields.moveSailLeft = false;
                            DataFields.sailInputDelay = 5;
                        }
                    }
                    else if (sailDirection == 2 && DataFields.sailInputDelay == 0)
                    {
                        if (DataFields.moveSailRight)
                        {
                            sailDirection = 1;
                            changedSailDirection = true;

                            player.Entity.StartAnimation("boatright");

                            DataFields.moveSailRight = false;
                            DataFields.sailInputDelay = 5;
                        }
                        else if (DataFields.moveSailLeft)
                        {
                            sailDirection = 3;
                            changedSailDirection = true;

                            player.Entity.StartAnimation("boatleft");

                            DataFields.moveSailLeft = false;
                            DataFields.sailInputDelay = 5;
                        }
                    }
                    else if (sailDirection == 3 && DataFields.sailInputDelay == 0)
                    {
                        if (DataFields.moveSailRight)
                        {
                            sailDirection = 2;
                            changedSailDirection = true;

                            player.Entity.StopAnimation("boatleft");

                            DataFields.moveSailRight = false;
                            DataFields.sailInputDelay = 5;
                        }
                    }
                }

                // Reset input bools when sail not down
                if (!DataFields.sailDown)
                {
                    changedSteerDirection = true;
                    changedSailDirection = true;

                    player.Entity.StopAnimation("boatright");
                    player.Entity.StopAnimation("boatleft");
                }

                // Put up sails
                // Sail-down rudder S,L,R sail-straight
                Item sailboatUnfolded_S_SS = api.World.GetItem(new AssetLocation("vsmovemod:sailboat-body-crafted-unfolded-straight-sailstraight-black"));
                ItemStack stackSailboatUnfolded_S_SS = new ItemStack(sailboatUnfolded_S_SS, 1);
                Item sailboatUnfolded_L_SS = api.World.GetItem(new AssetLocation("vsmovemod:sailboat-body-crafted-unfolded-left-sailstraight-black"));
                ItemStack stackSailboatUnfolded_L_SS = new ItemStack(sailboatUnfolded_L_SS, 1);
                Item sailboatUnfolded_R_SS = api.World.GetItem(new AssetLocation("vsmovemod:sailboat-body-crafted-unfolded-right-sailstraight-black"));
                ItemStack stackSailboatUnfolded_R_SS = new ItemStack(sailboatUnfolded_R_SS, 1);

                // Sail-down rudder S,L,R sail-left
                Item sailboatUnfolded_S_SL = api.World.GetItem(new AssetLocation("vsmovemod:sailboat-body-crafted-unfolded-straight-sailleft-black"));
                ItemStack stackSailboatUnfolded_S_SL = new ItemStack(sailboatUnfolded_S_SL, 1);
                Item sailboatUnfolded_L_SL = api.World.GetItem(new AssetLocation("vsmovemod:sailboat-body-crafted-unfolded-left-sailleft-black"));
                ItemStack stackSailboatUnfolded_L_SL = new ItemStack(sailboatUnfolded_L_SL, 1);
                Item sailboatUnfolded_R_SL = api.World.GetItem(new AssetLocation("vsmovemod:sailboat-body-crafted-unfolded-right-sailleft-black"));
                ItemStack stackSailboatUnfolded_R_SL = new ItemStack(sailboatUnfolded_R_SL, 1);

                // Sail-down rudder S,L,R sail-right
                Item sailboatUnfolded_S_SR = api.World.GetItem(new AssetLocation("vsmovemod:sailboat-body-crafted-unfolded-straight-sailright-black"));
                ItemStack stackSailboatUnfolded_S_SR = new ItemStack(sailboatUnfolded_S_SR, 1);
                Item sailboatUnfolded_L_SR = api.World.GetItem(new AssetLocation("vsmovemod:sailboat-body-crafted-unfolded-left-sailright-black"));
                ItemStack stackSailboatUnfolded_L_SR = new ItemStack(sailboatUnfolded_L_SR, 1);
                Item sailboatUnfolded_R_SR = api.World.GetItem(new AssetLocation("vsmovemod:sailboat-body-crafted-unfolded-right-sailright-black"));
                ItemStack stackSailboatUnfolded_R_SR = new ItemStack(sailboatUnfolded_R_SR, 1);

                // Sail up  rudder S, sail-straight
                Item sailboatFolded = api.World.GetItem(new AssetLocation("vsmovemod:sailboat-body-crafted-folded-straight-sailstraight-black"));
                ItemStack stackSailboatFolded = new ItemStack(sailboatFolded, 1);

                if (DataFields.sailDown && boatSlot.Itemstack.Collectible.Code.Path.StartsWith("sailboat-body-crafted"))
                {
                    // Rudder Straight
                    if (boatSteerStraight && (changedSteerDirection || changedSailDirection))
                    {
                        if (sailDirection == 1)
                        {
                            boatSlot.Itemstack = stackSailboatUnfolded_S_SR;
                            boatSlot.MarkDirty();
                        }
                        else if (sailDirection == 2)
                        {
                            boatSlot.Itemstack = stackSailboatUnfolded_S_SS;
                            boatSlot.MarkDirty();
                        }
                        else if (sailDirection == 3)
                        {
                            boatSlot.Itemstack = stackSailboatUnfolded_S_SL;
                            boatSlot.MarkDirty();
                        }

                        // Conditional soundeffect
                        if (changedSteerDirection)
                        {
                            // Sound rudder mid disabled
                            //api.World.PlaySoundFor(new AssetLocation("sounds/environment/smallsplash"), player, false, 100, 5);
                        }
                        else
                        {
                            api.World.PlaySoundFor(new AssetLocation("sounds/wearable/leather3"), player, false, 100, 5);
                        }

                        changedSteerDirection = false;
                        changedSailDirection = false;

                        //player.ShowChatNotification("STRAIGHT");
                    }
                    // Rudder Right
                    else if (boatSteerRight && (changedSteerDirection || changedSailDirection))
                    {
                        if (sailDirection == 1)
                        {
                            boatSlot.Itemstack = stackSailboatUnfolded_R_SR;
                            boatSlot.MarkDirty();
                        }
                        else if (sailDirection == 2)
                        {
                            boatSlot.Itemstack = stackSailboatUnfolded_R_SS;
                            boatSlot.MarkDirty();
                        }
                        else if (sailDirection == 3)
                        {
                            boatSlot.Itemstack = stackSailboatUnfolded_R_SL;
                            boatSlot.MarkDirty();
                        }

                        // Conditional soundeffect
                        if (changedSteerDirection)
                        {
                            api.World.PlaySoundFor(new AssetLocation("sounds/environment/smallsplash"), player, false, 100, 5);
                        }
                        else
                        {
                            api.World.PlaySoundFor(new AssetLocation("sounds/wearable/leather3"), player, false, 100, 5);
                        }

                        changedSteerDirection = false;
                        changedSailDirection = false;

                        //player.ShowChatNotification("RIGHT");
                    }
                    // Rudder Left
                    else if (boatSteerLeft && (changedSteerDirection || changedSailDirection))
                    {
                        if (sailDirection == 1)
                        {
                            boatSlot.Itemstack = stackSailboatUnfolded_L_SR;
                            boatSlot.MarkDirty();
                        }
                        else if (sailDirection == 2)
                        {
                            boatSlot.Itemstack = stackSailboatUnfolded_L_SS;
                            boatSlot.MarkDirty();
                        }
                        else if (sailDirection == 3)
                        {
                            boatSlot.Itemstack = stackSailboatUnfolded_L_SL;
                            boatSlot.MarkDirty();
                        }

                        // Conditional soundeffect
                        if (changedSteerDirection)
                        {
                            api.World.PlaySoundFor(new AssetLocation("sounds/environment/smallsplash"), player, false, 100, 5);
                        }
                        else
                        {
                            api.World.PlaySoundFor(new AssetLocation("sounds/wearable/leather3"), player, false, 100, 5);
                        }

                        changedSteerDirection = false;
                        changedSailDirection = false;

                        //player.ShowChatNotification("LEFT");
                    }
                }

                else if (!DataFields.sailDown && ((hasSailed && boatSlot.Itemstack.Collectible.Code.Path.StartsWith("sailboat-body-crafted")) || boatJustEntered))
                {
                    boatSlot.Itemstack = stackSailboatFolded;
                    boatSlot.MarkDirty();

                    hasSailed = false;
                    boatJustEntered = false;

                    //player.ShowChatNotification("STOP");
                    api.World.PlaySoundFor(new AssetLocation("sounds/wearable/leather1"), player, false, 100, 5);
                }
            }


                //*** Debug ***
                //player.ShowChatNotification("In Boatmode :" + DataFields.inBoatMode.ToString());
                //player.ShowChatNotification("Motion -Y :" + player.Entity.Pos.Motion.Y.ToString());
                //player.ShowChatNotification("Saildown :" + DataFields.sailDown.ToString());
                //player.ShowChatNotification("Head-Yaw :" + player.Entity.HeadYaw.ToString());
                //player.ShowChatNotification("Current steer :" + currentSteer.ToString());
                //player.ShowChatNotification("Changed direction :" + changedSteerDirection.ToString());
                //player.ShowChatNotification("Sail-Configuration: " + sailDirection.ToString());
                //player.ShowChatNotification("View-Direction: " + playerDirection.ToString());
                //player.ShowChatNotification("Wind-Direction: " + xwindDirection.ToString());
                //player.ShowChatNotification("Collided : " + boatCollided.ToString());
                //player.ShowChatNotification("Toggle Boat : " + DataFields.toggleSailboat.ToString());
                //player.ShowChatNotification("Wearing Sailshirt : " + isWearingSailerShirt.ToString());

            //Check for armor - legacy "sailshirt")
            DummySlot dummyCheckSlot = new DummySlot(StackSailShirt);

            foreach (var slot in gearInv)
            {
                ItemWearable item;
                if (slot.Empty || (item = slot.Itemstack.Collectible as ItemWearable) == null)
                {
                    if (slot.CanHold(dummyCheckSlot) && !isWearingSailerShirt)
                    {
                        boatSlot = slot;
                        isWearingSailerShirt = true;
                    }

                    continue; 
                }
                else if (slot.Itemstack.Collectible.Code.Path.StartsWith("armor-body-"))
                {
                    isWearingSailerShirt = false;
                }
            }

            // Player warning when trying to mount boat with armor
            if (!isWearingSailerShirt && (playerPosBlock == boatBlockN || playerPosBlock == boatBlockS || playerPosBlock == boatBlockE || playerPosBlock == boatBlockW))
            {
                if (DataFields.errorTimer < 1)
                {
                    player.ShowChatNotification("You don't fit into the boat while wearing body-armor");
                    DataFields.errorTimer = 200;
                }
            }

            // Activate Boat mode
            if (!DataFields.inBoatMode && DataFields.toggleSailboat && isWearingSailerShirt && !player.Entity.Controls.TriesToMove && !player.Entity.Controls.Sprint && !player.Entity.Controls.FloorSitting && !DataFields.isCrawling && above2Block == air && (playerPosBlock == boatBlockN || playerPosBlock == boatBlockS || playerPosBlock == boatBlockE || playerPosBlock == boatBlockW))
            {
                // Delete "Boat-Block" when entering
                DataFields.removeBoat = true;
                DataFields.boatUnmountTimer = 40;

                DataFields.inBoatMode = true;
                boatJustEntered = true;
                mountedBoat = true;
                player.Entity.SetCollisionBox(2f, 2f);

                //Stop motion
                Vec3d motionZero = new Vec3d(0, 0, 0);
                player.Entity.Pos.Motion = motionZero;

                //Pitch to 0 (swim pitch fix)
                player.Entity.WalkPitch = 0;

                //Stop animations
                player.Entity.StopAnimation("land");
                player.Entity.StopAnimation("glide");

                player.Entity.StopAnimation("swim");
                player.Entity.StopAnimation("swimidle");

                player.Entity.StopAnimation("idle");
                player.Entity.StopAnimation("sprint");
                player.Entity.StopAnimation("walk");

                player.Entity.StopAnimation("awaitdash");
                player.Entity.StopAnimation("gleiten");
                player.Entity.StopAnimation("liegen");

                player.Entity.StopAnimation("sneakwalk");
                player.Entity.StopAnimation("sneakidle");

                player.Entity.StopAnimation("sitflooridle");

                //TP to same position
                SyncedEntityPos playerPos = player.Entity.Pos;
                player.Entity.Pos.Y = playerPos.Y;
            }

            // Disable Boat mode
            if ((DataFields.inBoatMode && !playerPosBlock.IsLiquid() && DataFields.boatUnmountTimer < 1) || (DataFields.inBoatMode && mountedBoat && DataFields.boatUnmountTimer < 1 && (!DataFields.toggleSailboat || !isWearingSailerShirt )))
            {
                // Place "Boat-Block" when leaving boatmode
                if (playerDirection == Direction.North)
                {
                    DataFields.placeBoatN = true;

                    SyncedEntityPos syncedPos = player.Entity.Pos;
                    syncedPos.Y = syncedPos.Y + 1;
                    syncedPos.X = syncedPos.X + 1;
                    player.Entity.Pos = syncedPos;
                }
                else if (playerDirection == Direction.East)
                {
                    DataFields.placeBoatE = true;

                    SyncedEntityPos syncedPos = player.Entity.Pos;
                    syncedPos.Y = syncedPos.Y + 1;
                    syncedPos.Z = syncedPos.Z + 1;
                    player.Entity.Pos = syncedPos;
                }
                else if (playerDirection == Direction.South)
                {
                    DataFields.placeBoatS = true;

                    SyncedEntityPos syncedPos = player.Entity.Pos;
                    syncedPos.Y = syncedPos.Y + 1;
                    syncedPos.X = syncedPos.X + 1;
                    player.Entity.Pos = syncedPos;
                }
                else if (playerDirection == Direction.West)
                {
                    DataFields.placeBoatW = true;

                    SyncedEntityPos syncedPos = player.Entity.Pos;
                    syncedPos.Y = syncedPos.Y + 1;
                    syncedPos.Z = syncedPos.Z + 1;
                    player.Entity.Pos = syncedPos;
                }

                DataFields.inBoatMode = false;
                DataFields.sailDown = false;
                mountedBoat = false;
                hasSailed = false;
                playedBellSound = false;

                player.Entity.SetCollisionBox(0.5f, 2f);

                // Swap boatmodel to Sail-Shirt
                foreach (var slot in gearInv)
                {
                    ItemWearable item;
                    if (slot.Empty || (item = slot.Itemstack.Collectible as ItemWearable) == null) continue; // null Exception catch

                    if (slot.Itemstack.Collectible.Code.Path.StartsWith("sailboat-body-crafted"))
                    {
                        slot.Itemstack = null;
                        slot.MarkDirty();
                    }
                }

                // Reenable Inputs when leaving Boat mode
                if (!DataFields.isCrawling)
                {
                    api.Input.InWorldAction += Input_AllowAllMovements;
                    player.Entity.StopAnimation("boatidle");
                    player.Entity.StopAnimation("boatright");
                    player.Entity.StopAnimation("boatleft");
                }
            }
        }

        // Surrounded by water - no used
        private static bool SurroundedByWater(IBlockAccessor blockAccessor, BlockPos pos)
        {
            Block block = blockAccessor.GetBlock(pos.DownCopy());

            Block blockN = blockAccessor.GetBlock(pos.WestCopy().DownCopy());
            Block blockE = blockAccessor.GetBlock(pos.WestCopy().DownCopy());
            Block blockS = blockAccessor.GetBlock(pos.WestCopy().DownCopy());
            Block blockW = blockAccessor.GetBlock(pos.WestCopy().DownCopy());

            return blockN.IsLiquid() && blockE.IsLiquid() && blockS.IsLiquid() && blockW.IsLiquid();
        }

        private static void Input_PreventMovement(EnumEntityAction action, bool on, ref EnumHandling handled)
        {
            if(action == EnumEntityAction.Up)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.Down)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.Forward)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.Backward)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.Left)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.Right)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.Jump)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.Sneak)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.Sprint)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.FloorSit)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.RightMouseDown)
            {
                handled = EnumHandling.PreventDefault;
            }
            if (action == EnumEntityAction.LeftMouseDown)
            {
                handled = EnumHandling.PreventDefault;
            }
        }
        public static void Input_AllowAllMovements(EnumEntityAction action, bool on, ref EnumHandling handled)
        {
            if (action == EnumEntityAction.Up)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.Down)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.Forward)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.Backward)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.Left)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.Right)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.Jump)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.Sneak)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.Sprint)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.FloorSit)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.RightMouseDown)
            {
                handled = EnumHandling.PassThrough;
            }
            if (action == EnumEntityAction.LeftMouseDown)
            {
                handled = EnumHandling.PassThrough;
            }
        }
    }
}
